#ifndef __LAPTOP_HOTSWAP_H__
#define __LAPTOP_HOTSWAP_H__

#include <acpi/acpi.h>
#include <acpi/acpi_bus.h>
#include <acpi/acpi_drivers.h>

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,15)
#error "LTHS requires at least kernel 2.6.15 to compile"
#endif

struct lths_handler;

typedef void(*lths_eject_handler)(struct lths_handler *);

#define PS_EJ0	0x01
#define PS_EJ1	0x02
#define PS_EJ2	0x04
#define PS_EJ3	0x08
#define PS_EJ4	0x10


struct lths_handler {
  acpi_handle handle;
  char *path;
  acpi_notify_handler handler;
  acpi_notify_handler old_handler;
  lths_eject_handler eject;
  int num;
  int eject_ps;
  int present;
  int old_handler_type;
  void *old_context;
  char dev_class[20];
  char bus_id[15];
  char old_dev_class[20];
  char old_bus_id[15];
  struct lths_handler *next;
};


#define LTHS_DEVICE_MAX_PATHS	20 // yeah, I'm lazy.
struct lths_device {
  char bus_id[5];
  acpi_notify_handler handler;
  lths_eject_handler eject;
  int num;
  char *paths[LTHS_DEVICE_MAX_PATHS];
};







#endif // __LAPTOP_HOTSWAP_H__
